clear all
close all


%% Parameter setting

addpath(genpath('pdmethod'));
addpath(genpath('lambdaupdate'));

set_parameter;


%% Input the test image

input_pic=0;    % 0: use the given test image, 
                % 1: choose image by search window

B_0=input_image(input_pic);


%% Creat the degraded image

Z_0=degrade_image(B_0);


%% Primal-dual algorithm with spatially dependent parameter

[U_full,Lambda,k,res_out]=primal_dual_method(Z_0,lambda);


%% Output

% Final output and storage of modified pictures 
 disp(['The algorithm ends at iteration: ',num2str(k-1)])

% imwrite(U_full,[opicname,'.',info.Format])
 
figure(100)
axis off,axis image
colormap(gray);
imagesc(U_full);

figure(200)
semilogy(1:k,res_out), axis tight
title('Residual')
xlabel('Iteration number')
ylabel('Log10(residual)')

if local_var_est==1
    figure(300)
    axis off,axis image
    colormap(gray);
    imagesc(Lambda);
end
